create database docmanager with log;

create table InterestGroup
  (
	InterestGroupID serial(1) 	  NOT NULL PRIMARY KEY,
	InterestGroup   varchar(40,0)   NOT NULL,
	Description     varchar(255,50) NOT NULL
  );

create table User
  (
	UserId          varchar(8,0)    NOT NULL PRIMARY KEY,
	Password	    varchar(8,0)	  NOT NULL,
	LastName        varchar(50,0)   NOT NULL,
      FirstName       varchar(50,0)   NOT NULL,
	InterestGroupID integer 	  NOT NULL,
	AccessLevel	    char(1)		  NOT NULL,
	Email		    varchar(60,0),
	Phone           varchar(25,0),
	Fax		    varchar(25,0)
  );

create table Competitor
  (
	CompetitorID    serial(1)	  NOT NULL PRIMARY KEY,
	CompetitorName  varchar(60,0)   NOT NULL,
	URL             varchar(80,0)   NOT NULL,
	InterestGroupID integer 	  NOT NULL,
	Description     varchar(255,50) NOT NULL,
	OwnerId         varchar(8,0)    NOT NULL,
	ExpirationDate  date,
      ActivationDate  date,
      ModifiedDate    datetime year to fraction(3)
  );

create table MIMETypes
  (
	Format     	    varchar(30,0)   NOT NULL PRIMARY KEY,
	Type            varchar(40,0)   NOT NULL,
	Extension  	    varchar(15,0)   NOT NULL
  );

create table Folder
  (
      FolderID        serial(1)       NOT NULL,
	FolderName      varchar(40,0)   NOT NULL,
	InterestGroupID integer  	  NOT NULL,
	Group		    varchar(30,0)   NOT NULL,
	Description     varchar(255,50) NOT NULL,
	OwnerId         varchar(8,0)    NOT NULL,
	PRIMARY KEY (FolderID,InterestGroupID,Group)
  );

create table File
  (
	FileName	    varchar(40,0)   NOT NULL PRIMARY KEY,
	Location	    varchar(80,0)	  NOT NULL,
	Description     varchar(255,50) NOT NULL,
	Format          varchar(30,0)	  NOT NULL,
	OwnerId         varchar(8,0)    NOT NULL,
	FolderID        integer  	  NOT NULL,
	ExpirationDate  date,
	ActivationDate  date,
	ModifiedDate    datetime year to fraction(3)
  );

create table Bulletin
  (
	BulletinID      serial(1) 	  NOT NULL PRIMARY KEY,
	Title		    varchar(60,0)	  NOT NULL,
	InterestGroupID integer  	  NOT NULL,
	Content	    varchar(255,50) NOT NULL,
	OwnerId         varchar(8,0)    NOT NULL,
	ExpirationDate  date,
	ActivationDate  date,
	ModifiedDate    datetime year to fraction(3)
  );

create table ScrollKey
(
  UserId              varchar(8,0)    NOT NULL,
  TableName           varchar(15,0)   NOT NULL,
  PageNum             integer         NOT NULL,
  AlphaKey1           varchar(80,0),
  AlphaKey2           varchar(80,0),
  NumKey1             integer,
  NumKey2             integer,
  PRIMARY KEY(UserID, TableName, PageNum)
);

create table Config
(
   ConfigName          char(20)       NOT NULL PRIMARY KEY,
   ServerName          varchar(100)   NOT NULL,
   Phase1              varchar(255),
   Phase2              varchar(255),
   Phase3              varchar(255),
   Phase4              varchar(255),
   Phase5              varchar(255)
);

load from "interestgroup.unl" insert into InterestGroup;
load from "user.unl"          insert into User;
load from "bulletin.unl"      insert into Bulletin;
load from "competitor.unl"    insert into Competitor;
load from "mimetypes.unl"     insert into MIMETypes;
load from "folder.unl"        insert into Folder;

grant resource to public;
