/*  <!--- Application: Sales and Marketing Knowledge Site Lite for		--->
<!---              Appalanche Project					--->
<!--- Version    : 1.0.0						--->
<!--- Filename   : engine.js						--->
<!--- Description: 
		This js file contains the main search engine functions.
		It dynamically builds the sql, and then submits it.
									--->
<!---									--->	
<!---              							--->
<!--- Parameters : 							--->
<!--- 		   							--->
<!--- Valid Vals :							--->
<!---  									--->	
<!--- Company    : Sage Solutions, Inc.					--->
<!--- Revisions  : Tim Hall 8/22/96		(original code)		--->
<!---              							--->
<!---									--->
*/


/* The following function is a dynamic SQL generator for searching the file/folder tables to retrieve
     searched for files. The SQL parameters used depend on the input supplied by the user.  */

function file_db_string()
   { var todays_date = makeToday();
     head_string = "select file.filename, file.location, folder.folderid, folder.foldername, folder.group, file.description "+
                   "from file, folder where folder.folderid =  file.folderid and ";
     var search_string = " folder.interestgroupid = "+request.interestgroupid;
     if (request.expired != "expired")
     { search_string = search_string + ' and file.expirationdate >= "'+todays_date+'" ';
     }
     if (request.area == "title")
     { search_string = search_string + " and file.filename like '%"+request.search_text+"%' ";
     }
     else
     { search_string = search_string + " and file.description like '%"+unescape(request.search_text)+"%' ";
     }
     tail_string = " order by file.filename, folder.group, folder.foldername";

// After all components are determined, the variable result becomes the entire SQL string statement.

   result = head_string+search_string+tail_string;

   return result;
   }

/* The following function is a dynamic SQL generator for searching the bulletin table to retrieve
     searched for bulletins.  The SQL parameters used depend on the input supplied by the user. */

function bull_db_string()
    { var todays_date = makeToday();
      head_string = "SELECT title, content, expirationdate, bulletin.interestgroupid, interestgroup.interestgroup, MONTH(activationdate) AS ac_mon, DAY(activationdate) AS ac_day, YEAR(activationdate) AS ac_year, " + 

" MONTH(expirationdate) AS ex_mon, DAY(expirationdate) AS ex_day, YEAR(expirationdate) AS ex_year "+
                   "FROM bulletin, interestgroup WHERE (bulletin.interestgroupid = interestgroup.interestgroupid) AND ";
      var search_string = " bulletin.interestgroupid = "+request.interestgroupid;
     if (request.expired != "expired")
     { search_string = ""+search_string+"" + ' AND expirationdate >= "'+todays_date+'" ';
     }
     if (request.area == "title")
     { search_string = "" + search_string+"" + ' AND bulletin.title like "%'+""+unescape(request.search_text)+""+'%" ';
     }
     else
     { search_string = ""+search_string +""+ ' AND bulletin.content like "%'+""+request.search_text+""+'%" ';
     }
     tail_string = "ORDER BY expirationdate desc, title";
	
// After all components are determined, the variable result becomes the entire SQL string statement.
   result = ""+head_string+""+search_string+""+tail_string+"";

   return result;
   }

/* The following function is a dynamic SQL generator for searching the bulletin table to retrieve
     searched for bulletins.  The SQL parameters used depend on the input supplied by the user. */

function comp_db_string()
{var todays_date = makeToday();
    head_string = "SELECT competitorname, url, competitor.description, expirationdate, competitor.interestgroupid, interestgroup.interestgroup "+
                   "FROM competitor, interestgroup WHERE (competitor.interestgroupid = interestgroup.interestgroupid) AND ";
      var search_string = " competitor.interestgroupid = "+request.interestgroupid;

     if (request.expired != "expired")
     { search_string = search_string + ' AND expirationdate >= "'+todays_date+'" ';
     }
     if (request.area == "title")
     { search_string = search_string + ' AND competitorname like "%'+unescape(request.search_text)+'%" ';
     }
     else
     { search_string = search_string + ' AND competitor.description like "%'+request.search_text+'%" ';
     }
     tail_string = "ORDER BY competitorname, expirationdate desc";
// After all components are determined, the variable result becomes the entire SQL string statement.

   result = head_string+search_string+tail_string;

   return result;

}
