/*========================================================================
  Function:    upd_scroll

  Parameters:  none

  Returns:     n/a

  Description: 	This function updates the scrollkey table with information  necessary to create
		a "page" of data on a sys admin screen.  The update is used when a user returns to a page 		they have accessed once before.  The alpha and numkey fields are updated because the 			data on the table may have changed (rows inserted or deleted) since the last access. A 			page is defined as 10 rows.

		The content of the generic alphakey and numkey fields is specific to the				table which is being accessed by a particular sys admin function.


  ========================================================================
*/
function upd_scroll()
{	
	updresult = database.execute('UPDATE scrollkey SET alphakey1 = "' + this.alphakey1 
							 	      + '", numkey1 = "' + this.numkey1  
								    + '", alphakey2 = "' + this.alphakey2 
									+ '", numkey2 = "' + this.numkey2 
				          + '" WHERE userid = "' + this.userid + '" AND tablename = "' + this.tablename + '" AND pagenum = "' + this.pagenum + '"');
	
	if(updresult !=0)
	  {write("<p>Start of Update, result code = " + updresult + "</p>");
     	   write("<p> major error code = " + database.majorErrorCode() + "</p>");
    	   write("<p> msg =" + database.majorErrorMessage() + "</p>");
    	   write("<p> minor code= " + database.minorErrorCode() + "</p>");
    	   write("<p> minor -end of update " + database.minorErrorMessage() + "</p>");
        }
}


/*========================================================================
  Function:    ins_scroll

  Parameters:  none

  Returns:     insresult

  Description: This query inserts rows into the scrollkey table.  The row it enters is keyed by userid(the user using the system) pagenum(the page number the user is on) and tablename( the table they are accessing in sys admin.

When the user accesses the page for this row, the values of the numkey and alpha key fields will drive the SQL query which actually creates that page of data.  A page is defined as 10 rows of data within the sys admin function.
  ========================================================================
*/
function ins_scroll()
{	
	insresult = database.execute('INSERT INTO scrollkey (userid, tablename, pagenum, alphakey1, alphakey2, numkey1, numkey2) VALUES("' 
                                   + this.userid + '", "' + this.tablename + '", "' + this.pagenum + '", "' + this.alphakey1 + '", "' 
                                   + this.alphakey2 + '", "' + this.numkey1 + '", "' + this.numkey2 + '")');
	
	if((insresult !=0) && (insresult !=7))
	 {write("<p>Start of Insert, result code = " + insresult + "</p>");
    	  write("<p> major error code = " + database.majorErrorCode() + "</p>");
    	  write("<p> msg =" + database.majorErrorMessage() + "</p>");
    	  write("<p> minor code= " + database.minorErrorCode() + "</p>");
    	  write("<p> minor -end of insert " + database.minorErrorMessage() + "</p>");
         };

		
	return insresult;
}

/*========================================================================
  Function:    sel_scroll

  Parameters:  none

  Returns:     n/a

  Description: This function selects a row from scroll key corresponding to the page numer the user wants to access.  The numkey and alphkey fields are then used to drive the specific sys admin query, and build the page the user wants to access.
  ========================================================================
*/
function sel_scroll()
{	
	pageinfo = database.cursor('SELECT alphakey1, alphakey2, numkey1, numkey2 FROM scrollkey WHERE userid = "' + this.userid + '" AND tablename = "' + this.tablename + '" AND pagenum = "' + this.pagenum + '"');
	
	pageinfo.next();
	this.alphakey1 = ""+pageinfo.alphakey1+"";
	this.alphakey2 = ""+pageinfo.alphakey2+"";
	this.numkey1 = pageinfo.numkey1;
	this.numkey2 = pageinfo.numkey2;
	
	pageinfo.close();

}

/*========================================================================
  Function:    TopPage

  Parameters:  userid, tablename, pagenum, alphakey1, alphakey2, numkey1,
               numkey2

  Returns:     The TopPage object

  Description: This function creates the TopPage object. Once created, it's method's are accessed to insert, select and update rows on scrollkey.
  ========================================================================
*/
function TopPage(userid, tablename, pagenum, alphakey1, alphakey2, numkey1, numkey2)
{
	this.userid 	=	userid;
	this.tablename	=	tablename;
	this.pagenum	=	pagenum;
	this.alphakey1	=	alphakey1;
	this.alphakey2	=	alphakey2;
	this.numkey1	=	numkey1;
	this.numkey2	=	numkey2;
	this.ins_scroll	=	ins_scroll;
	this.upd_scroll	=	upd_scroll;
	this.sel_scroll	=	sel_scroll;
}

/*========================================================================
  Function:    check_size

  Parameters:  temp_var, var_size

  Returns:     temp_var

  Description: This function takes the length of temp_var and compares it
               to the desired length, var_size.  If temp_var is greater
               than var_size, temp_var is truncated to var_size.  Then,
               temp_var is returned to the application.

  ========================================================================
*/
function check_size(temp_var, var_size)
{ if (temp_var.length > var_size)
   { result = temp_var.substring(0,(parseInt(var_size)-1));
   }
  else 
   { result = temp_var;
   }
  return result;
} 

/*========================================================================
  Function:    header

  Parameters:  none

  Returns:     n/a

  Description: This function displays the Sales and Marketing 
               KnowledgeSite Lite banner.

  ========================================================================
*/
function header()
{ 
  write('<CENTER>');
  write('<IMG SRC="./images/head1.jpg" ALT="Sales KnowledgeSite Lite">');
  write('</CENTER>');
}

/*========================================================================
  Function:    file_admin_header

  Parameters:  nextpage

  Returns:     n/a

  Description: This function displays an image map. HREFs are created 
               dynamically based on the nextpage parameter.  The same
               image map is being used, but the destination page needs
               to be different based on the calling page.

  ========================================================================
*/
function file_admin_header(nextpage)
{
//8/5 change sa082 to sa07 for this function only

write('<CENTER>');
  write('<IMG USEMAP="#saleproc.map" SRC="./images/saleproc.jpg" ALT="Sales Process" BORDER="0">');
  write('<MAP NAME="saleproc.map">');
  write('<!--- default home --->');
  write("<AREA SHAPE='rect' COORDS='1,1,73,85'     HREF="+nextpage+"?group=Generating+Leads>");
  write("<AREA SHAPE='rect' COORDS='75,1,154,83'   HREF="+nextpage +"?group=Preparing+the+Proposal>");
  write("<AREA SHAPE='rect' COORDS='157,1,227,85'  HREF="+nextpage+"?group=Gaining+Commitment>");
  write("<AREA SHAPE='rect' COORDS='229,1,306,84' HREF="+nextpage+"?group=Delivering+Value>");
  write("<AREA SHAPE='rect' COORDS='307,0,377,85'  HREF="+nextpage+"?group=Gathering+Feedback>");
  write('</MAP>');
  write('</CENTER>');
}

/*========================================================================
  Function:    file_admin_footer

  Parameters:  nextpage

  Returns:     n/a

  Description: This function displays an text based links. HREFs are 
               created dynamically based on the nextpage parameter.  
               The same image map is being used, but the destination page 
		   needs to be different based on the calling page.

  ========================================================================
*/
function file_admin_footer(nextpage)
{
  write('<A HREF="'+nextpage+'?group=Generating+Leads">Generating Leads</A><BR>');
  write('<A HREF="'+nextpage+'?group=Preparing+the+Proposal">Preparing the Proposal</A><BR>');
  write('<A HREF="'+nextpage+'?group=Gaining+Commitment">Gaining Commitment</A><BR>');
  write('<A HREF="'+nextpage+'?group=Delivering+Value">Delivering Value</A><BR>');
  write('<A HREF="'+nextpage+'?group=Gathering+Feedback">Gathering Feedback</A><BR>');
}

/*========================================================================
  Function:    footer

  Parameters:  none

  Returns:     n/a

  Description: This function displays the Sage Solutions, Inc. footer 
		   information in the bottom most frame.

  ========================================================================
*/
function footer()
{
  write('<CENTER>');
  write('<IMG USEMAP="#foot1.map" SRC="./images/foot1.jpg" ALT="Sage Solutions, Inc." BORDER=0>'); //HEIGHT=80 WIDTH=468
  write('<MAP NAME="foot1.map">');
  write('<!--- default home --->');
  write("<AREA SHAPE='rect' COORDS='195,2,339,19'  HREF='http://www.sagesoln.com' TARGET='Display'>");
  write("<AREA SHAPE='rect' COORDS='195,20,340,35' HREF='mailto:sales@sagesoln.com'>");
  write("<AREA SHAPE='rect' COORDS='5,51,342,65'   HREF='mailto:navigat9@sirius.com'>");
  write("<AREA SHAPE='rect' COORDS='3,3,193,45'    HREF='http://www.sagesoln.com' TARGET='Display'>");
  write("</MAP>");
  write("<BR>");
  write('Comments, suggestions, or problems?  We welcome <A HREF="mailto:sales@sagesoln.com">feedback</A>.<BR>');
  write('</CENTER>');
}

/*========================================================================
  Function:    makeToday

  Parameters:  none

  Returns:     result - a string formatted in mm/dd/yyyy format

  Description: This function gets today's date from the system and 
		   transforms it into an mm/dd/yyyy string format.  This
               string is returned to the calling variable.

  ========================================================================
*/
function makeToday()
{ temp_date = new Date();

  result = (parseInt(temp_date.getMonth())+1)+"/"+temp_date.getDate()+"/"+(parseInt(temp_date.getYear())+1900);

  return result;
}

/*========================================================================
  Function:    todayPlus

  Parameters:  num_units, type

  Returns:     result - a date string formatted in mm/dd/yyyy format

  Description: This function takes a numeric value (num_units) and
               a type ("M" - month, "D" - day, "Y" - year) as inputs.  
               Using today's date, it then performs an addition of the
               numeric value to the appropriate portion of the date. The
               result of the addition is then extracted from the date 
               object and formatted into mm/dd/yyyy and returned.
               (passing in negative units will cause a subtraction to
                be performed, as expected.)

  ========================================================================
*/
function todayPlus(num_units, type)
{ temp_date = new Date();

  result = "mm/dd/yyyy";

  if (type == "D")
   { 
    temp_date.setDate((parseInt(temp_date.getDate()) + num_units)); 
    result = (parseInt(temp_date.getMonth())+1)+"/"+temp_date.getDate()+"/"+(parseInt(temp_date.getYear())+1900);
   }
  if (type == "M")
   { 
    temp_date.setMonth((parseInt(temp_date.getMonth()) + num_units)); 
    result = (parseInt(temp_date.getMonth())+1)+"/"+temp_date.getDate()+"/"+(parseInt(temp_date.getYear())+1900);
   }
  if (type == "Y")
   { 
    temp_date.setYear((parseInt(temp_date.getYear()) + num_units)); 
    result = (parseInt(temp_date.getMonth())+1)+"/"+temp_date.getDate()+"/"+(parseInt(temp_date.getYear())+1900);
   }
  
  
  return result;
}

/*========================================================================
  Function:    todayPlusObj

  Parameters:  num_units, type

  Returns:     temp_date - date object

  Description: This function performs the same functionality as todayPlus.
               The difference is that this function returns the actual
               date object rather than a formatted string.

  ========================================================================
*/
function todayPlusObj(num_units, type)
{ temp_date = new Date();

  if (type == "D")
   { 
    temp_date.setDate((parseInt(temp_date.getDate()) + num_units)); 
   }
  if (type == "M")
   { 
    temp_date.setMonth((parseInt(temp_date.getMonth()) + num_units)); 
   }
  if (type == "Y")
   { 
    temp_date.setYear((parseInt(temp_date.getYear()) + num_units)); 
   }
  
  
  return temp_date;
}

/*========================================================================
  Function:    makeLibHeader

  Parameters:  none

  Returns:     n/a

  Description: This function displays the A-Z, 0-9, and ALL HREFs along
               the top of the Knowledge Index page.
               
  ========================================================================
*/
function makeLibHeader()
{ write('<CENTER>');
  write('<P>');
  write('<A HREF=kindex.html?card=A>A</A> ');
  write('<A HREF=kindex.html?card=B>B</A> ');
  write('<A HREF=kindex.html?card=C>C</A> ');
  write('<A HREF=kindex.html?card=D>D</A> ');
  write('<A HREF=kindex.html?card=E>E</A> ');
  write('<A HREF=kindex.html?card=F>F</A> ');
  write('<A HREF=kindex.html?card=G>G</A> ');
  write('<A HREF=kindex.html?card=H>H</A> ');
  write('<A HREF=kindex.html?card=I>I</A> ');
  write('<A HREF=kindex.html?card=J>J</A> ');
  write('<A HREF=kindex.html?card=K>K</A> ');
  write('<A HREF=kindex.html?card=L>L</A> ');
  write('<A HREF=kindex.html?card=M>M</A> ');
  write('<A HREF=kindex.html?card=N>N</A> ');
  write('<A HREF=kindex.html?card=O>O</A> ');
  write('<A HREF=kindex.html?card=P>P</A> ');
  write('<A HREF=kindex.html?card=Q>Q</A> ');
  write('<A HREF=kindex.html?card=R>R</A> ');
  write('<A HREF=kindex.html?card=S>S</A> ');
  write('<A HREF=kindex.html?card=T>T</A> ');
  write('<A HREF=kindex.html?card=U>U</A> ');
  write('<A HREF=kindex.html?card=V>V</A> ');
  write('<A HREF=kindex.html?card=W>W</A> ');
  write('<A HREF=kindex.html?card=X>X</A> ');
  write('<A HREF=kindex.html?card=Y>Y</A> ');
  write('<A HREF=kindex.html?card=Z>Z</A> ');
  write('<A HREF=kindex.html?card=0>0</A> ');
  write('<A HREF=kindex.html?card=1>1</A> ');
  write('<A HREF=kindex.html?card=2>2</A> ');
  write('<A HREF=kindex.html?card=3>3</A> ');
  write('<A HREF=kindex.html?card=4>4</A> ');
  write('<A HREF=kindex.html?card=5>5</A> ');
  write('<A HREF=kindex.html?card=6>6</A> ');
  write('<A HREF=kindex.html?card=7>7</A> ');
  write('<A HREF=kindex.html?card=8>8</A> ');
  write('<A HREF=kindex.html?card=9>9</A> ');
  write('<A HREF=kindex.html?card=ALL>ALL</A>');
  write('</P>');
  write('</CENTER>');
}

/*========================================================================
  Function:    createSearchstring

  Parameters:  start_char

  Returns:     result - part of a WHERE clause for an SQL query

  Description: This function takes a character as a parameter.  According
               to the character passed, a portion of a WHERE clause is
               generated to support a search based on the character.  A
               lowercase letter indicates a specific range of characters
               to search.  An uppercase letter indicates a lower and upper
               case search for that specific letter.               

  ========================================================================
*/
function createSearchstring(start_char)
{ 
  result = "file.filename <> '' ";
 
  if (start_char == "a")
  { result = "((file.filename like 'a%') or (file.filename like 'A%') or "+
              "(file.filename like 'b%') or (file.filename like 'B%') or "+
              "(file.filename like 'c%') or (file.filename like 'C%') or "+
		  "(file.filename like 'd%') or (file.filename like 'D%') or "+
 		  "(file.filename like 'e%') or (file.filename like 'E%'))"
  }

  if (start_char == "f")
  { result = "((file.filename like 'f%') or (file.filename like 'F%') or "+
              "(file.filename like 'g%') or (file.filename like 'G%') or "+
              "(file.filename like 'h%') or (file.filename like 'H%') or "+
		  "(file.filename like 'i%') or (file.filename like 'I%') or "+
 		  "(file.filename like 'j%') or (file.filename like 'J%'))"
  }

  if (start_char == "k")
  { result = "((file.filename like 'k%') or (file.filename like 'K%') or "+
              "(file.filename like 'l%') or (file.filename like 'L%') or "+
              "(file.filename like 'm%') or (file.filename like 'M%') or "+
		  "(file.filename like 'n%') or (file.filename like 'N%') or "+
 		  "(file.filename like 'o%') or (file.filename like 'O%'))"
  }

  if (start_char == "p")
  { result = "((file.filename like 'p%') or (file.filename like 'P%') or "+
              "(file.filename like 'q%') or (file.filename like 'Q%') or "+
              "(file.filename like 'r%') or (file.filename like 'R%') or "+
		  "(file.filename like 's%') or (file.filename like 'S%') or "+
 		  "(file.filename like 't%') or (file.filename like 'T%'))"
  }

  if (start_char == "u")
  { result = "((file.filename like 'u%') or (file.filename like 'U%') or "+
              "(file.filename like 'v%') or (file.filename like 'V%') or "+
              "(file.filename like 'w%') or (file.filename like 'W%') or "+
		  "(file.filename like 'x%') or (file.filename like 'X%') or "+
 		  "(file.filename like 'y%') or (file.filename like 'Y%') or "+
              "(file.filename like 'z%') or (file.filename like 'Z%'))"
  }

  if (start_char == "A")
  { result = "((file.filename like 'a%') or (file.filename like 'A%'))"
  } 

  if (start_char == "B")
  { result = "((file.filename like 'b%') or (file.filename like 'B%'))"
  }

  if (start_char == "C")
  { result = "((file.filename like 'c%') or (file.filename like 'C%'))"
  }

  if (start_char == "D")
  { result = "((file.filename like 'd%') or (file.filename like 'D%'))"
  }

  if (start_char == "E")
  { result = "((file.filename like 'e%') or (file.filename like 'E%'))"
  }

  if (start_char == "F")
  { result = "((file.filename like 'f%') or (file.filename like 'F%'))"
  }

  if (start_char == "G")
  { result = "((file.filename like 'g%') or (file.filename like 'G%'))"
  }

  if (start_char == "H")
  { result = "((file.filename like 'h%') or (file.filename like 'H%'))"
  }

  if (start_char == "I")
  { result = "((file.filename like 'i%') or (file.filename like 'I%'))"
  }

  if (start_char == "J")
  { result = "((file.filename like 'j%') or (file.filename like 'J%'))"
  }

  if (start_char == "K")
  { result = "((file.filename like 'k%') or (file.filename like 'K%'))"
  }

  if (start_char == "L")
  { result = "((file.filename like 'l%') or (file.filename like 'L%'))"
  }

  if (start_char == "M")
  { result = "((file.filename like 'm%') or (file.filename like 'M%'))"
  }

  if (start_char == "N")
  { result = "((file.filename like 'n%') or (file.filename like 'N%'))"
  }

  if (start_char == "O")
  { result = "((file.filename like 'o%') or (file.filename like 'O%'))"
  }

  if (start_char == "P")
  { result = "((file.filename like 'p%') or (file.filename like 'P%'))"
  }

  if (start_char == "Q")
  { result = "((file.filename like 'q%') or (file.filename like 'Q%'))"
  }

  if (start_char == "R")
  { result = "((file.filename like 'r%') or (file.filename like 'R%'))"
  }

  if (start_char == "S")
  { result = "((file.filename like 's%') or (file.filename like 'S%'))"
  }

  if (start_char == "T")
  { result = "((file.filename like 't%') or (file.filename like 'T%'))"
  }

  if (start_char == "U")
  { result = "((file.filename like 'u%') or (file.filename like 'U%'))"
  }

  if (start_char == "V")
  { result = "((file.filename like 'v%') or (file.filename like 'V%'))"
  }

  if (start_char == "W")
  { result = "((file.filename like 'w%') or (file.filename like 'W%'))"
  }

  if (start_char == "X")
  { result = "((file.filename like 'x%') or (file.filename like 'X%'))"
  }

  if (start_char == "Y")
  { result = "((file.filename like 'y%') or (file.filename like 'Y%'))"
  }

  if (start_char == "Z")
  { result = "((file.filename like 'z%') or (file.filename like 'Z%'))"
  }

  if (start_char == "0")
  { result = "(file.filename like '0%')"
  }

  if (start_char == "1")
  { result = "(file.filename like '1%')"
  }

  if (start_char == "2")
  { result = "(file.filename like '2%')"
  }

  if (start_char == "3")
  { result = "(file.filename like '3%')"
  }

  if (start_char == "4")
  { result = "(file.filename like '4%')"
  }

  if (start_char == "5")
  { result = "(file.filename like '5%')"
  }

  if (start_char == "6")
  { result = "(file.filename like '6%')"
  }

  if (start_char == "7")
  { result = "(file.filename like '7%')"
  }

  if (start_char == "8")
  { result = "(file.filename like '8%')"
  }

  if (start_char == "9")
  { result = "(file.filename like '9%')"
  }
  
  if (client.accesslevel == "U")
  { result = result + " and ((folder.interestgroupid = "+client.interestgroupid+") OR (folder.interestgroupid = 1)) ";
  }
  result = result + " and activationdate <= TODAY AND expirationdate >= TODAY ";

  return result;
}  

/*========================================================================
  Function:    groupHeader

  Parameters:  group, type

  Returns:     n/a

  Description: This function displays an image based on the group passed.
               System administration uses this function in the File and
               Folder selection pages.  The type indicates whether it is
               a file or folder page.               

  ========================================================================
*/
function groupHeader(group, type)
{ 

write('<CENTER>');

  if (group == "Generating Leads")
    { image_file ="phase1.jpg";
    }
  if (group == "Preparing the Proposal")
    { image_file ="phase2.jpg";
    }
  if (group == "Gaining Commitment")
    { image_file ="phase3.jpg";
    }
  if (group == "Delivering Value")
    { image_file ="phase4.jpg";
    }
  if (group == "Gathering Feedback")
    { image_file ="phase5.jpg";
    }

write('<table><TR>');
write('<TD><IMG SRC="./images/'+image_file+'" ALIGN=MIDDLE ALT="Sales Phase: '+group+'"></TD>');
write("<TD><H2> System Administration</H2><p><H2>" + type + " Selection</H2></p></TD></TR>");  
write('</table></CENTER>');
}

/*========================================================================
  Function:    groupDescription

  Parameters:  group

  Returns:     n/a

  Description: This function displays an image and some related text based
               on the phase passed in the parameter.               

  ========================================================================
*/
function groupDescription(group)
{ 
  if (group == "Generating Leads")
    { 
	write("<TR><TD><IMG SRC='./images/phase1.jpg' ALT='Generating Leads'></TD>");
	write("<TD><b><I>The first phase of any sales process involves generating a pool  of possible prospects that may be interested in your company's products or services.</b></I></TD></TR>");
    }
  
if (group == "Preparing the Proposal")
    { 
	write("<TR><TD><IMG SRC='./images/phase2.jpg' ALT='Preparing the Proposal'></TD>");
	write("<TD><b><I>This phase involves qualifying of leads, and addressing the customer's concerns in a positive manner. </b></I> </TD></TR>");
    }
  
if (group == "Gaining Commitment")
    { 
	write("<TR><TD><IMG SRC='./images/phase3.jpg' ALT='Gaining Commitment'></TD>");
	write("<TD><b><I>Securing  business can depend on issues as simple as assessing possible concerns or correctly structuring contract language.  Familiarity with these issues on previous sales is invaluable. </b></I></TD></TR>");
    }
  
if (group == "Delivering Value")
    { 
	write("<TR><TD><IMG SRC='./images/phase4.jpg' ALT='Delivering Value'></TD>");
	write("<TD><b><I>Delivering goods and services to the client is made simpler when tools such as company contacts, order forms and inventory information are readily available. </b></I></TD></TR>");
    }
  
if (group == "Gathering Feedback")
    { 
	write("<TR><TD><IMG SRC='./images/phase5.jpg' ALT='Gathering Feedback'></TD>");
	write("<TD><b><I>Since the best clients are the ones already known, the final phase of any sales process involves managing existing relationships and listening to client feedback to ensure future sales. </b></I></TD></TR>");
    }
 
}

/*========================================================================
  Function:    Print_No_Found

  Parameters:  none

  Returns:     n/a

  Description: When a table does not contain any data.  This message is diplayed to the user.  For example, if the user wanted to see a list of folders within a particular sales phase, and none existed, this message would be shown.

  ========================================================================
*/
function Print_No_Found()
{write("<center><p><b><I>No Data Found That Met The Search Criteria</I></b></p></center>");
}

/*========================================================================
  Function:    escape_string

  Parameters:  strname

  Returns:     tempstr - a reformatted string

  Description: This function removes " and replaces it with &quot.  Other
               values that need to be replaced can be put here. The way
               we implemented ' vs. " required that we replaced " with
               &quot in order for us to successfully insert text with "
               into the database.               

  ========================================================================
*/
function escape_string(strname) {
  
  tempstr="";
  if (strname) {
    for (i=0;i<strname.length;i++) {
      if (strname.substring(i,i+1) == '"') {
	tempstr += '&quot;';
      } else {
	tempstr += strname.substring(i,i+1);
      }
    }
  }
  return(tempstr);
}

/*========================================================================
  Function:    check_text_entry

  Parameters:  strname

  Returns:     tempstr - a reformatted string

  Description: This function strips out newline and carriage returns from
               strings. As well as calling additional functions to replace
               other troublesome characters.               

  ========================================================================
*/
function check_text_entry(strname) {
  
  gotspace=0;
  tempstr="";
  for (i=0;i<strname.length;i++) {
    if (gotspace) {// already found non-space character 
	if ((strname.substring(i,i+1) == "\n") ||
	  (strname.substring(i,i+1) == "\r")) {
	tempstr += " ";
      } else {
	tempstr += strname.substring(i,i+1);
      }
    } else {
      if (strname.substring(i,i+1) != " ") { // if space, skip it.
	tempstr += strname.substring(i,i+1);
	gotspace=1;
      }
    }
  }

  if (!tempstr) {
    tempstr="null";
    return (tempstr);
  } else {
    return(escape_string(tempstr));
  }
}

/*========================================================================
  Function:    makeClientScriptDateFunction

  Parameters:  none

  Returns:     n/a

  Description: This function writes a client-side JavaScript function on
               to a page when it is called. The client-function itself
               receives a string and attempts to determine whether it
               is a valid date.  Leap year, 30 vs. 31 days, valid month
               and days are checked.   Separators are mostly ignored and
               replaced with '/'.  But, all types of separators will be
               accepted (i.e. mm.dd.yyyy or mm-dd-yy).  Year formatting
               is also handled. If the year is a two digit year, then
               numbers from 70 to 99 are added to 1900 and 00 to 69 are
               added to 2000.  If the date is valid, a reformatted date
               string is returned (mm/dd/yyyy).  Otherwise a specific
               error message is returned indicating the type of error 
               encountered.               

  ========================================================================
*/
function makeClientScriptDateFunction()
{write('<SCRIPT language=javascript>\n');
 write('function validate_date(date_str){\n');

 write('   var month_val= "";\n');
 write('   var sep1 = "/";\n');
 write('   var day_val = "";\n');
 write('   var sep2 = "/";\n');
 write('   var year_val = "";\n');
 write('   var string_date_str = ""+date_str+"";\n');
 write('   var length_of_date_str = string_date_str.length;\n');
 write('   var i = 0;\n');
 write('   var j = 1;\n');
 write('   var first_sep  = false;\n');
 write('   var second_sep = false;\n');


        // Check for date string too long or too short (don't worry about the year 10000!)
 write('  if ((parseInt(length_of_date_str) < 6) || (parseInt(length_of_date_str) > 10))\n');
 write('    { \n');
 write('    return "Unrecognized Date String. Date format should be: mm/dd/yyyy";\n');
 write('    } \n');
        
        //Separate String into Date Components

 write('  while (j <= parseInt(length_of_date_str))\n');
 write('  { \n');
	    // Format year if both separators have been passed
 write('   if ((first_sep) && (second_sep))\n');
 write('    {if ((parseInt(date_str.substring(i,j)) >= 0) && ((parseInt(date_str.substring(i,j)) <= 9))) \n');
 write('      { year_val = year_val + date_str.substring(i,j) //take advantage of the string nature (i.e. 1+0 = 10)\n');
 write('      }\n');
 write('     else \n');
 write('      { return "Invalid character in Date! Date format should be: mm/dd/yyyy";\n');
 write('      }\n');
 write('    }\n');

          // Format day if the second separators has not been passed
 write('   if ((first_sep) && (!second_sep))\n');
 write('    { if ((parseInt(date_str.substring(i,j)) >= 0) && ((parseInt(date_str.substring(i,j)) <= 9))) \n');
 write('       { day_val = day_val + date_str.substring(i,j) //take advantage of the string nature (i.e. 1+0 = 10)\n');
 write('       }\n');
 write('      else\n');
 write('       { second_sep = true;\n');
 write('       }\n');
 write('    }\n');

          // Format day if the first separators has not been passed
 write('   if (!first_sep )\n');
 write('    { if ((parseInt(date_str.substring(i,j)) >= 0) && ((parseInt(date_str.substring(i,j)) <= 9)))\n');
 write('       { month_val = month_val + date_str.substring(i,j) //take advantage of the string nature (i.e. 1+0 = 10)\n');
 write('       }\n');
 write('      else\n');
 write('       { first_sep = true;\n');
 write('       }\n');
 write('    }\n');

         // increment counters
 write('    i++;\n');
 write('    j++;\n');
 write(' }\n');

	 
        // Check for valid month 
 write('if ((month_val.length == 2) && (month_val.substring(0,1) == 0))');
 write('{month_val = month_val.substring(1,2)}');
 write('if ((parseInt(month_val) < 1) || (parseInt(month_val) > 12))\n');
 write('{\n');
 write('    return "Month portion of date is invalid!";\n');
 write('}\n');

        // Check for valid day
 write('if ((day_val.length == 2) && (day_val.substring(0,1) == 0))');
 write('{day_val = day_val.substring(1,2)}');
 write('if ((parseInt(day_val) < 1) || (parseInt(day_val) > 31))\n');
 write('{\n');
 write('        return "Day portion of date is invalid!";\n');
 write('}\n');

        // Check for valid year should be yyyy or yy
 write('if ((year_val.length != 4) && (year_val.length !=2))\n');
 write('{\n');
 write('       return "Year portion of date is invalid!";\n');
 write('}\n');
        
 write('if (year_val.length == 2)  //if in yy format adjust to 19yy or 20yy\n');
 write('{\n');
 write('  if (parseInt(year_val) < 70)\n');
 write('   { year_val = ""+(parseInt(year_val)+ 2000)+"";\n');
 write('   }\n');
 write('   else\n');
 write('   { year_val = ""+(parseInt(year_val)+ 1900)+"";\n');
 write('   }\n');
 write('}\n');


     // Day and Month Cross Validation
       
        // Months with 30 days
 write('if ((parseInt(month_val) == 4) || (parseInt(month_val) == 6) ||(parseInt(month_val) == 9) || (parseInt(month_val) == 11))\n');
 write('   { if (parseInt(day_val) > 30)\n');
 write('     {\n');
 write('       return "Invalid number of days for the given month!";\n');
 write('     }\n');
 write('   }\n');

        // February stuff
 
 write('if (parseInt(month_val) == 2)\n');
 write('   { if ((parseInt(year_val) % 4) == 0) \n');
 write('      { if ((((year_val.substring(2,4) == "00") && ((parseInt(year_val) % 400) == 0))) || (year_val.substring(2,4) != "00"))');
 write('        { if (parseInt(day_val) > 29)\n');
 write('         { \n');
 write('           return "Invalid number of days for the given month!";\n');
 write('         }\n');
 write('        }\n');
 write('        else\n');
 write('        { if (parseInt(day_val) > 28)\n');
 write('	      { return "This year is not a leap year!";\n');
 write('          }\n');
 write('        }\n');
 write('      }\n');
 write('     else\n');
 write('      { if (parseInt(day_val) > 28)\n');
 write('	    { return "This year is not a leap year!";\n');
 write('        }\n');
 write('      }\n');
 write('   }\n');
// if we got passed all this other stuff, the date must be ok and we reformat it and pass it back
// we change any kind of separator to a "/" so "." or "-" or spaces are ok.

 write('  result = ""+month_val+sep1+day_val+sep2+year_val+"";\n');
 
 write('return result;\n');

 write('}\n');
 write('</SCRIPT>\n');
}


/*========================================================================
  Function:    get_int_grp

  Parameters:  usr_intgrpid, all

  Returns:     n/a

  Description: This function creates a drop list containing
               interest groups.  It either contains the ALL option or not
               based on the all parameter.

  ========================================================================
*/
function get_int_grp(usr_intgrpid, all)   
{if (all == "N")
  {intg_info = database.cursor('SELECT interestgroupid, interestgroup FROM interestgroup WHERE interestgroupid > 1  ORDER BY interestgroup');
  }
 else
  {if (client.accesslevel == "A")
    {intg_info = database.cursor('SELECT interestgroupid, interestgroup FROM interestgroup ORDER BY interestgroup');
    }
   else
    {intg_info = database.cursor('SELECT interestgroupid, interestgroup FROM interestgroup WHERE ((interestgroupid = 1) OR (interestgroupid ='+
                                  client.interestgroupid+')) ORDER BY interestgroup');
    }
  }

 write('<TR>');
 write('<TH ALIGN=RIGHT>Interest Group</TH>');
 write('<TD><SELECT NAME=interestgroupid>');
  while(intg_info.next())
  { if(usr_intgrpid == intg_info.interestgroupid)
     {write('<OPTION SELECTED VALUE="'+intg_info.interestgroupid+'">'+intg_info.interestgroup);}
    else
     {write('<OPTION VALUE="'+intg_info.interestgroupid+'">'+intg_info.interestgroup);}
  }
 intg_info.close();
 write('</SELECT>');
 write('</TR>');
}

/*========================================================================
  Function:    get_folders

  Parameters:  usr_group, usr_folderid, usr_access

  Returns:     n/a

  Description: This function creates a drop list containing
               the folders for a specific group based on user accesslevel.

  ========================================================================
*/
function get_folders(usr_group, usr_folderid, usr_access)   
{if (usr_access == "A")
  { folder_info = database.cursor('SELECT folderid, foldername FROM folder WHERE group = "'+usr_group+'" ORDER BY foldername');
  }
 else
  { folder_info = database.cursor('SELECT folderid, foldername, interestgroupid FROM folder WHERE group = "'+usr_group+'" AND ((interestgroupid = 1) OR (interestgroupid = '+client.interestgroupid+')) ORDER BY foldername');
  }
 write('<TR>');
 write('<TH ALIGN=RIGHT>Folder</TH>');
 write('<TD><SELECT NAME=folderid>');
  while(folder_info.next())
  { if(usr_folderid == folder_info.folderid)
     {write('<OPTION SELECTED VALUE="'+folder_info.folderid+'">'+folder_info.foldername);}
    else
     {write('<OPTION VALUE="'+folder_info.folderid+'">'+folder_info.foldername);}
  }
 folder_info.close();
 write('</SELECT>');
 write('</TR>');
}

/*========================================================================
  Function:    get_format

  Parameters:  usr_format

  Returns:     n/a

  Description: This function creates a drop list containing
               MIME type formats. 

  ========================================================================
*/
function get_formats(usr_format)  
{format_info = database.cursor('SELECT format FROM mimetypes ORDER BY format');
  
 write('<TR>');
 write('<TH ALIGN=RIGHT>Format</TH>');
 write('<TD><SELECT NAME=format>');
  while(format_info.next())
  { if (usr_format == format_info.format)
     {write('<OPTION SELECTED VALUE="'+format_info.format+'">'+format_info.format);}
    else
     {write('<OPTION VALUE="'+format_info.format+'">'+format_info.format);}
  }
 format_info.close();
 write('</SELECT>');
 write('</TR>');
}

/*========================================================================
  Function:    get_owners

  Parameters:  usr_id

  Returns:     n/a

  Description: This function creates a drop list containing
               a list of valid users to select an owner from.

  ========================================================================
*/
function get_owners(usr_id)   
{owner_info = database.cursor('SELECT userid FROM user ORDER BY userid');
  
 write('<TR>');
 write('<TH ALIGN=RIGHT>Owner ID</TH>');
 write('<TD><SELECT NAME=ownerid>');
  while(owner_info.next())
  { if (usr_id == owner_info.userid)
     {write('<OPTION SELECTED VALUE="'+owner_info.userid+'">'+owner_info.userid);}
    else
     {write('<OPTION VALUE="'+owner_info.userid+'">'+owner_info.userid);}
  }
 owner_info.close();
 write('</SELECT>');
 write('</TR>');
}


/*========================================================================
  Function:    int_grp_multi

  Parameters:  none

  Returns:     n/a

  Description: This function creates a selection box containing
               interest groups.  It contains the ALL option.  This is 
               used on the Search page.

  ========================================================================
*/
function int_grp_multi()   //Creates select box for interest groups showing 5
{if (client.accesslevel == "A")
  {intg_info = database.cursor('SELECT interestgroupid, interestgroup FROM interestgroup WHERE interestgroupid >= 1  ORDER BY interestgroup');
  }
 else
  {intg_info = database.cursor('SELECT interestgroupid, interestgroup FROM interestgroup WHERE (interestgroupid = 1) OR (interestgroupid ='+
                                  client.interestgroupid+')');
  }
 write('<SELECT NAME="interestgroupid" SIZE="5">');
 while(intg_info.next())
  { if (intg_info.interestgroupid == 1) 
      {selected = "SELECTED";} 
    else
      {selected = "";}
   write('<OPTION '+selected+' VALUE="'+intg_info.interestgroupid+'">'+intg_info.interestgroup);
  }
 write('</SELECT><BR>');
 intg_info.close();

}

